diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
index 4bbb7f230..e0cb5f672 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
@@ -1,70 +1,216 @@
 package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.ScreenHudEditor;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.option.Option;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.enums.ArmorHiddenState;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.enums.IArmorShape;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemArmor;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.item.material.ArmorMaterial;
+import org.jetbrains.annotations.Nullable;
 
-public class HudComponentArmorBar
-    extends HudComponentMovable {
-    private final IconCoordinate armor_empty;
-    private final IconCoordinate armor_half;
-    private final IconCoordinate armor_full;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Random;
 
-    public HudComponentArmorBar(String key, Layout layout) {
-        super(key, 81, 10, layout);
-        this.armor_empty = TextureRegistry.getTexture("minecraft:gui/hud/armor_empty");
-        this.armor_half = TextureRegistry.getTexture("minecraft:gui/hud/armor_half");
-        this.armor_full = TextureRegistry.getTexture("minecraft:gui/hud/armor_full");
+public class HudComponentArmorBar extends HudComponentMovable {
+
+    private final Random random = new Random();
+
+    public record CustomItemData(IArmorShape shape, String id) {}
+
+    public static final Map<IArmorShape, String> SHAPE_MAP = new HashMap<>();
+    public static final Map<ArmorMaterial, String> MATERIAL_MAP = new HashMap<>();
+    public static final Map<Item, CustomItemData> CUSTOM_ITEM_MAP = new HashMap<>();
+
+    static {
+        SHAPE_MAP.put(HumanArmorShape.HEAD, "helmet");
+        SHAPE_MAP.put(HumanArmorShape.CHEST, "chestplate");
+        SHAPE_MAP.put(HumanArmorShape.LEGS, "leggings");
+        SHAPE_MAP.put(HumanArmorShape.BOOTS, "boots");
+
+        MATERIAL_MAP.put(ArmorMaterial.LEATHER, "leather");
+        MATERIAL_MAP.put(ArmorMaterial.IRON, "iron");
+        MATERIAL_MAP.put(ArmorMaterial.GOLD, "gold");
+        MATERIAL_MAP.put(ArmorMaterial.CHAINMAIL, "chainmail");
+        MATERIAL_MAP.put(ArmorMaterial.DIAMOND, "diamond");
+        MATERIAL_MAP.put(ArmorMaterial.STEEL, "steel");
+
+        CUSTOM_ITEM_MAP.put(Items.ARMOR_BOOTS_ICESKATES, new CustomItemData(HumanArmorShape.BOOTS, "iceskates"));
+        CUSTOM_ITEM_MAP.put(Items.ARMOR_QUIVER, new CustomItemData(HumanArmorShape.CHEST, "quiver"));
+        CUSTOM_ITEM_MAP.put(Items.ARMOR_QUIVER_GOLD, new CustomItemData(HumanArmorShape.CHEST, "quiver_gold"));
+    }
+
+    public enum ArmorState {
+        EMPTY, HALF, FULL, INFINITE;
+
+        public String getRegistry() {
+            return this.name().toLowerCase();
+        }
+
+        public static ArmorState calculate(double currentDurability, double maxDurability) {
+            if (maxDurability <= 0) return INFINITE;
+            if (currentDurability <= 0) return EMPTY;
+
+            double durabilityPercentage = currentDurability / maxDurability;
+
+            if (durabilityPercentage > 0.50) return FULL;
+            return HALF;
+        }
+    }
+
+    private record ArmorIconKey(IArmorShape shape, ArmorState state, @Nullable ArmorMaterial material, boolean isFlipped) {}
+    private record CustomIconKey(IArmorShape shape, ArmorState state, String customId, boolean isFlipped) {}
+
+    private record ArmorPiece(IArmorShape shape, @Nullable ArmorMaterial material, @Nullable String customId, ArmorState state, double currentDurability, double maxDurability) {
+        public boolean isCustom() {
+            return customId != null;
+        }
+    }
+
+    private final IArmorShape targetShape;
+
+    private final Map<ArmorIconKey, IconCoordinate> icons = new HashMap<>();
+    private final Map<CustomIconKey, IconCoordinate> customIcons = new HashMap<>();
+
+    public HudComponentArmorBar(String key, Layout layout, IArmorShape targetShape) {
+        super(key, 9, 12, layout);
+        this.targetShape = targetShape;
     }
 
     @Override
-    public boolean isVisible() {
-        return GameSettings.IMMERSIVE_MODE.drawHotbar() && mc.thePlayer.getPlayerProtectionAmount() > 0 && GameSettings.ARMOR_BAR_OVERLAY.value;
+    public int getDisplayedYSize() {
+        int baseSize = super.getDisplayedYSize();
+        if (baseSize == 0) return 0;
+
+        if (mc.currentScreen instanceof ScreenHudEditor) {
+            return 12;
+        }
+
+        ArmorPiece piece = getWornArmorPiece();
+        if (piece == null || piece.state() == ArmorState.EMPTY) {
+            return 9;
+        }
+
+        return 12;
+    }
+
+    private boolean isFlipped() {
+        if (this.targetShape == HumanArmorShape.HEAD) return GameSettings.FLIP_HELMET_BAR.value;
+        if (this.targetShape == HumanArmorShape.CHEST) return GameSettings.FLIP_CHESTPLATE_BAR.value;
+        if (this.targetShape == HumanArmorShape.LEGS) return GameSettings.FLIP_LEGGINGS_BAR.value;
+        if (this.targetShape == HumanArmorShape.BOOTS) return GameSettings.FLIP_BOOTS_BAR.value;
+        return false;
+    }
+
+    private ArmorHiddenState getHiddenState() {
+        if (this.targetShape == HumanArmorShape.HEAD) return GameSettings.HIDE_HELMET_BAR.value;
+        if (this.targetShape == HumanArmorShape.CHEST) return GameSettings.HIDE_CHESTPLATE_BAR.value;
+        if (this.targetShape == HumanArmorShape.LEGS) return GameSettings.HIDE_LEGGINGS_BAR.value;
+        if (this.targetShape == HumanArmorShape.BOOTS) return GameSettings.HIDE_BOOTS_BAR.value;
+        return ArmorHiddenState.NEVER;
+    }
+
+    private IconCoordinate getIconForState(ArmorPiece piece, boolean isFlipped) {
+        if (piece.isCustom()) {
+            CustomIconKey key = new CustomIconKey(piece.shape(), piece.state(), piece.customId(), isFlipped);
+            return customIcons.computeIfAbsent(key, this::loadCustomIcon);
+        } else {
+            ArmorMaterial fetchMaterial = (piece.state() == ArmorState.EMPTY) ? null : piece.material();
+            ArmorIconKey key = new ArmorIconKey(piece.shape(), piece.state(), fetchMaterial, isFlipped);
+            return icons.computeIfAbsent(key, this::loadArmorIcon);
+        }
+    }
+
+    private IconCoordinate loadCustomIcon(CustomIconKey key) {
+        String shapeDir = SHAPE_MAP.getOrDefault(key.shape(), "unknown");
+
+        boolean applyFlip = key.isFlipped() && key.state() == ArmorState.HALF;
+        String stateDir = key.state().getRegistry() + (applyFlip ? "/flipped" : "");
+
+        String path = "minecraft:gui/hud/armor/" + shapeDir + "/" + stateDir + "/" + key.customId();
+        return TextureRegistry.getTexture(path);
+    }
+
+    private IconCoordinate loadArmorIcon(ArmorIconKey key) {
+        String shapeDir = SHAPE_MAP.getOrDefault(key.shape(), "unknown");
+
+        boolean applyFlip = key.isFlipped() && key.state() == ArmorState.HALF;
+        String stateDir = key.state().getRegistry() + (applyFlip ? "/flipped" : "");
+
+        if (key.state() == ArmorState.EMPTY) {
+            String path = "minecraft:gui/hud/armor/" + shapeDir + "/" + stateDir + "/empty";
+            return TextureRegistry.getTexture(path);
+        } else {
+            String matDir = MATERIAL_MAP.getOrDefault(key.material(), "unknown");
+            String path = "minecraft:gui/hud/armor/" + shapeDir + "/" + stateDir + "/" + matDir;
+            return TextureRegistry.getTexture(path);
+        }
     }
 
     @Override
-    public boolean isPreviewTranslucent() {
-        return !GameSettings.ARMOR_BAR_OVERLAY.value;
+    public boolean isVisible() {
+        ArmorHiddenState hiddenState = getHiddenState();
+
+        if (hiddenState == ArmorHiddenState.ALWAYS) {
+            return false;
+        }
+
+        if (!GameSettings.IMMERSIVE_MODE.drawHotbar()) {
+            return false;
+        }
+
+        if (hiddenState == ArmorHiddenState.WHEN_NOT_WEARING) {
+            ArmorPiece piece = getWornArmorPiece();
+            return piece != null && piece.state() != ArmorState.EMPTY;
+        }
+
+        return true;
     }
 
     @Override
-    public Option<?> getAttachedOption() {
-        return GameSettings.ARMOR_BAR_OVERLAY;
+    public boolean isPreviewTranslucent() {
+        return getHiddenState() == ArmorHiddenState.ALWAYS;
     }
 
     @Override
     public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        ArmorPiece piece = getWornArmorPiece();
+
+        if (piece == null) {
+            piece = new ArmorPiece(this.targetShape, null, null, ArmorState.EMPTY, 0, 0);
+        }
+
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
-        // Setup rendering
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GLRenderer.disableState(State.BLEND);
+        int iconY = y;
 
-        int armorValue = mc.thePlayer.getPlayerProtectionAmount();
-        for (int i = 0; i < 10; i++) {
-            if (armorValue > 0) {
-                int xArmor = x + getXSize() - i * 8 - 9;
-                if (i * 2 + 1 < armorValue) {
-                    // Full armor icon
-                    hud.drawGuiIcon(xArmor, y, 9, 9, this.armor_full);
-                }
-                if (i * 2 + 1 == armorValue) {
-                    // Half armor icon
-                    hud.drawGuiIcon(xArmor, y, 9, 9, this.armor_half);
-                }
-                if (i * 2 + 1 > armorValue) {
-                    // Empty armor icon
-                    hud.drawGuiIcon(xArmor, y, 9, 9, this.armor_empty);
-                }
-            }
+        if (piece.maxDurability() > 0 && (piece.currentDurability() / piece.maxDurability()) <= 0.15 && piece.state() != ArmorState.EMPTY) {
+            this.random.setSeed(hud.updateCounter * 0x4c627L);
+            iconY += this.random.nextInt(2);
         }
+
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        GLRenderer.enableState(State.BLEND);
+
+        boolean isFlipped = this.isFlipped();
+
+        hud.drawGuiIcon(x, iconY, 9, 9, getIconForState(piece, isFlipped));
+        drawDurabilityBar(hud, x, y, piece.state(), piece.currentDurability(), piece.maxDurability(), 0xFF, isFlipped);
+
+        GLRenderer.disableState(State.BLEND);
     }
 
     @Override
@@ -72,26 +218,97 @@ public class HudComponentArmorBar
         int x = layout.getComponentX(this, xSizeScreen);
         int y = layout.getComponentY(this, ySizeScreen);
 
-        // Setup rendering
-
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         renderTranslucency();
 
-        int armorValue = 11;
-        for (int i = 0; i < 10; i++) {
-            int xArmor = x + getXSize() - i * 8 - 9;
-            if (i * 2 + 1 < armorValue) {
-                // Full armor icon
-                gui.drawGuiIcon(xArmor, y, 9, 9, this.armor_full);
-            }
-            if (i * 2 + 1 == armorValue) {
-                // Half armor icon
-                gui.drawGuiIcon(xArmor, y, 9, 9, this.armor_half);
+        ArmorPiece previewPiece;
+        int alpha = isPreviewTranslucent() ? 0x55 : 0xFF;
+
+        if (this.targetShape == HumanArmorShape.HEAD) {
+            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.LEATHER, null, ArmorState.HALF, 45, 100);
+        } else if (this.targetShape == HumanArmorShape.CHEST) {
+            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.IRON, null, ArmorState.HALF, 35, 100);
+        } else if (this.targetShape == HumanArmorShape.LEGS) {
+            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.GOLD, null, ArmorState.HALF, 25, 100);
+        } else {
+            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.DIAMOND, null, ArmorState.HALF, 15, 100);
+        }
+
+        boolean isFlipped = this.isFlipped();
+
+        gui.drawGuiIcon(x, y, 9, 9, getIconForState(previewPiece, isFlipped));
+        drawDurabilityBar(gui, x, y, previewPiece.state(), previewPiece.currentDurability(), previewPiece.maxDurability(), alpha, isFlipped);
+
+        GLRenderer.disableState(State.BLEND);
+    }
+
+    private void drawDurabilityBar(Gui gui, int x, int y, ArmorState state, double currentDurability, double maxDurability, int alpha, boolean isFlipped) {
+        int barMaxWidth = 9;
+        int barY = y + 10;
+
+        int a = alpha << 24;
+
+        gui.drawRect(x, barY, x + 9, barY + 2, a);
+
+        if (state == ArmorState.INFINITE) {
+            int magentaColor = (0xFFFF00FF & 0x00FFFFFF) | a;
+            gui.drawRect(x, barY, x + barMaxWidth, barY + 1, magentaColor);
+            return;
+        }
+
+        if (maxDurability <= 0) barMaxWidth = 8;
+
+        int barWidth = (int) Math.round((currentDurability / maxDurability) * barMaxWidth);
+        int progress = (int) Math.round((currentDurability / maxDurability) * 255D);
+
+        int colorFG = java.awt.Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
+        int colorBG = ((0xFF - progress) / 4) << 16 | 0x3f00;
+
+        colorFG = (colorFG & 0x00FFFFFF) | a;
+        colorBG = (colorBG & 0x00FFFFFF) | a;
+
+        gui.drawRect(x, barY, x + barMaxWidth, barY + 1, colorBG);
+
+        if (barWidth > 0) {
+            if (isFlipped) {
+                int startX = x + barMaxWidth - barWidth;
+                gui.drawRect(startX, barY, startX + barWidth, barY + 1, colorFG);
+            } else {
+                gui.drawRect(x, barY, x + barWidth, barY + 1, colorFG);
             }
-            if (i * 2 + 1 > armorValue) {
-                // Empty armor icon
-                gui.drawGuiIcon(xArmor, y, 9, 9, this.armor_empty);
+        }
+    }
+
+    private @Nullable ArmorPiece getWornArmorPiece() {
+        if (mc.thePlayer == null) return null;
+
+        for (ItemStack itemStack : mc.thePlayer.inventory.armorInventory) {
+            if (itemStack == null) continue;
+
+            Item item = itemStack.getItem();
+
+            if (CUSTOM_ITEM_MAP.containsKey(item)) {
+                CustomItemData data = CUSTOM_ITEM_MAP.get(item);
+                if (data.shape() == this.targetShape) {
+                    double maxDurability = itemStack.getMaxDamage();
+                    double currentDurability = maxDurability > 0 ? maxDurability - itemStack.getItemDamageForDisplay() : 0;
+                    ArmorState state = ArmorState.calculate(currentDurability, maxDurability);
+                    return new ArmorPiece(this.targetShape, null, data.id(), state, currentDurability, maxDurability);
+                }
+            } else if (item instanceof ItemArmor<?> armor) {
+                if (armor.getArmorShape() == this.targetShape) {
+                    ArmorMaterial material = armor.getArmorMaterial();
+                    double maxDurability = itemStack.getMaxDamage();
+                    double currentDurability = maxDurability > 0 ? maxDurability - itemStack.getItemDamageForDisplay() : 0;
+                    ArmorState state = ArmorState.calculate(currentDurability, maxDurability);
+                    return new ArmorPiece(this.targetShape, material, null, state, currentDurability, maxDurability);
+                }
+            } else if (this.targetShape == HumanArmorShape.HEAD) {
+                String customId = (item instanceof ItemBlock) ? "block_generic" : "item_generic";
+                return new ArmorPiece(this.targetShape, null, customId, ArmorState.INFINITE, 0, 0);
             }
         }
-        GLRenderer.disableState(State.BLEND);
+
+        return null;
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
index 38ff5b86e..d6526d6fd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
@@ -35,11 +35,6 @@ public class HudComponentArmorDurability
         return !GameSettings.ARMOR_DURABILITY_OVERLAY.value;
     }
 
-    @Override
-    public Option<?> getAttachedOption() {
-        return GameSettings.ARMOR_DURABILITY_OVERLAY;
-    }
-
     @Override
     public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(this, xSizeScreen);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java
new file mode 100644
index 000000000..df19902d8
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java
@@ -0,0 +1,169 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.ScreenHudEditor;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.Option;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.util.helper.Time;
+import org.jetbrains.annotations.NotNull;
+
+public class HudComponentDynamicTooltip extends HudComponentMovable {
+
+    private int lastItemID = -1;
+    private int lastSelectedItem = -1;
+
+    private String itemString;
+    private int itemColor;
+    private double itemTime = 0.0;
+
+    private String systemString;
+    private int systemColor;
+    private double systemTime = 0.0;
+
+    private final double displayTime = 2.5;
+    private final double fadeTime = 0.5;
+
+    private final String PREVIEW_TEXT = "Diamond Pickaxe";
+
+    public HudComponentDynamicTooltip(String key, Layout layout) {
+        super(key, 0, 8, layout);
+    }
+
+    @Override
+    public boolean isVisible() {
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawHotbar();
+        }
+        return GameSettings.IMMERSIVE_MODE.drawHotbar() && !GameSettings.HIDE_DYNAMIC_TOOLTIP.value;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_DYNAMIC_TOOLTIP.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudEditor) && !isVisible())) return 0;
+        return mc.font.stringWidth(getDisplayText());
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return mc.font.stringWidth(getDisplayText());
+    }
+
+    private String getDisplayText() {
+        if (mc.currentScreen instanceof ScreenHudEditor) return PREVIEW_TEXT;
+
+        if (this.systemString != null && this.systemTime > 0.0) return this.systemString;
+        if (this.itemString != null && this.itemTime > 0.0) return this.itemString;
+
+        return "";
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        if (!isVisible()) return;
+
+        if (mc.thePlayer != null) {
+            ItemStack item = mc.thePlayer.getCurrentEquippedItem();
+            int id = getItemID(item);
+            int i = mc.thePlayer.inventory.getCurrentSlot();
+
+            if (id != this.lastItemID || i != this.lastSelectedItem) {
+                updateItemString(item);
+                this.itemTime = this.displayTime;
+                this.lastItemID = id;
+                this.lastSelectedItem = i;
+                this.systemTime = 0.0;
+            }
+        }
+
+        if (!mc.isGamePaused) {
+            if (this.systemTime > 0.0) this.systemTime -= Time.delta;
+            if (this.itemTime > 0.0) this.itemTime -= Time.delta;
+        }
+
+        String activeString = null;
+        int activeColor = 0;
+        double activeTime = -1.0;
+
+        if (this.systemString != null && this.systemTime > 0.0) {
+            activeString = this.systemString;
+            activeColor = this.systemColor;
+            activeTime = this.systemTime;
+        } else if (this.itemString != null && this.itemTime > 0.0) {
+            activeString = this.itemString;
+            activeColor = this.itemColor;
+            activeTime = this.itemTime;
+        }
+
+        if (activeString == null || activeTime <= 0.0) return;
+
+        double alpha = (activeTime < this.fadeTime) ? (activeTime / this.fadeTime) : 1.0;
+        int a = (int) (alpha * 255);
+        if (a < 1) return;
+
+        int rgb = (activeColor & 0x00FFFFFF) | (a << 24);
+
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        if (a < 255) {
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        }
+
+        mc.font.render(activeString, x, y).setShadow().setColor(rgb).call();
+
+        GLRenderer.disableState(State.BLEND);
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
+
+        renderTranslucency();
+
+        int rgb = (0x00FFFFFF) | (255 << 24);
+        mc.font.render(PREVIEW_TEXT, x, y).setShadow().setColor(rgb).call();
+    }
+
+    private void updateItemString(ItemStack item) {
+        if (item == null) {
+            this.itemString = null;
+            return;
+        }
+        this.itemString = item.getDisplayName();
+        this.itemColor = Colors.allChatColors[item.getDisplayColor()].getARGB();
+    }
+
+    private int getItemID(ItemStack stack) {
+        if (stack == null) return -1;
+        return stack.getItem().id;
+    }
+
+    public void setOptionNameAndValueString(@NotNull Option<?> option) {
+        setString(option.getDisplayStringName() + ": " + option.getDisplayString());
+    }
+
+    public void setString(String string) {
+        setString(string, 0xFFFFFF);
+    }
+
+    public void setString(String string, int color) {
+        this.systemString = string;
+        this.systemColor = color;
+        this.systemTime = this.displayTime;
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
index 62da02c17..cf9ade42a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
@@ -8,15 +8,54 @@ import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 
-public class HudComponentFireBar
-    extends HudComponentMovable {
+public class HudComponentFireBar extends HudComponentMovable {
+
     public HudComponentFireBar(String key, Layout layout) {
-        super(key, 81, 10, layout);
+        super(key, 81, 9, layout);
+    }
+
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_FIRE_BAR.value;
+    }
+
+    private boolean isFlipped() {
+        return GameSettings.FLIP_FIRE_BAR.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        return this.isVertical() ? super.getDisplayedYSize() : super.getDisplayedXSize();
+    }
+
+    @Override
+    public int getDisplayedYSize() {
+        return this.isVertical() ? super.getDisplayedXSize() : super.getDisplayedYSize();
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return this.isVertical() ? super.getTrueYSize() : super.getTrueXSize();
+    }
+
+    @Override
+    public int getTrueYSize() {
+        return this.isVertical() ? super.getTrueXSize() : super.getTrueYSize();
     }
 
     @Override
     public boolean isVisible() {
-        return GameSettings.IMMERSIVE_MODE.drawHotbar() && !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && mc.thePlayer.remainingFireTicks > 0;
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawHotbar();
+        }
+        return GameSettings.IMMERSIVE_MODE.drawHotbar() &&
+                !mc.thePlayer.getGamemode().hasInvulnerablePlayer() &&
+                mc.thePlayer.remainingFireTicks > 0 &&
+                !GameSettings.HIDE_FIRE_BAR.value;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_FIRE_BAR.value;
     }
 
     @Override
@@ -31,8 +70,22 @@ public class HudComponentFireBar
         float fire = (float) mc.thePlayer.remainingFireTicks / (float) mc.thePlayer.maxFireTicks;
         int fireBar = (int) Math.min(fire * 20, 20);
 
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
         for (int i = 0; i < fireBar / 2; i++) {
-            hud.drawGuiIcon(x + i * 8, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
+            int xIcon;
+            int yIcon;
+
+            if (isVertical) {
+                xIcon = x;
+                yIcon = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xIcon = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yIcon = y;
+            }
+
+            hud.drawGuiIcon(xIcon, yIcon, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
         }
     }
 
@@ -43,11 +96,26 @@ public class HudComponentFireBar
 
         // Setup rendering
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        renderTranslucency();
         GLRenderer.enableState(State.BLEND);
 
-        int fireBar = 11;
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
+        int fireBar = 11; 
         for (int i = 0; i < fireBar / 2; i++) {
-            gui.drawGuiIcon(x + i * 8, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
+            int xIcon;
+            int yIcon;
+
+            if (isVertical) {
+                xIcon = x;
+                yIcon = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xIcon = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yIcon = y;
+            }
+
+            gui.drawGuiIcon(xIcon, yIcon, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
         }
     }
-}
+}
\ No newline at end of file
